var types = {syn: "synonyms", 
             ant: "antonyms", 
             rel: "related terms", 
             sim: "similar terms",
             usr: "user suggestions"};

function thesaurusSetup() {
}

function send() {
  var word = $("Source").value;
  if (word.length > 0) { 
    load(word);
  }  
}

function load(word) {
  var parent = $("Data").parentNode;
  parent.removeChild($("Data"));
  var data = document.createElement("script");
  data.type = "text/javascript";
  data.src = "http://words.bighugelabs.com/api/2/535c65a22c136cc27b4cc67f6b626d1f/" + encodeURIComponent(word) + "/json?callback=receive";
  data.id = "Data";
  data.onerror = function() {
    $("Loading").style.display = "none";
    $("Result").innerHTML = "Request Failed";
    scrollArea.refresh();    
  }
  data.onload = function() {
    $("Loading").style.display = "none";
    if ($("Result").innerHTML.length == 0) {
      $("Result").innerHTML = "Word not found";
      scrollArea.refresh();    
    }  
  }
  parent.appendChild(data);
  addToHistory(word);
  $("Result").innerHTML = "";
  scrollArea.refresh();    
  $("Loading").style.display = "block";
}

function receive(data) {
  var result = "";
  for (var key in data) {
  	result += "<div class='wordType'>" + key + ":";
  	for (var type in data[key]) {
  	  var typeWord = types[type];
  	  if (!typeWord) {
  	    typeWord = type;
  	  }  	  
    	result += "<div class='wordType2'>" + typeWord + ":<div class='words'>";
    	var words = data[key][type]; 
    	for (var i = 0; i < words.length; i++) {
    	  if (i > 0) {
    	    result += ", "
    	  }
    		result += "<div class='word' onclick='insert(\"" + words[i] + "\")'>" + words[i] + "</div>";
    	}
    	result += "</div></div>";
  	}
  	result += "</div>";
  }
  $("Result").innerHTML = result;
  scrollArea.refresh();
}

function insert(word) {
  $("Source").value = word;
  //window.open("#Form", "_self");
}

function addToHistory(word) {
  var element = document.createElement("div");
  element.className = "word";
  element.onclick = function() {
    insert(word);
  }
  element.innerHTML = word;
  if ($("History").innerHTML.length > 0) {
    $("History").appendChild(document.createTextNode(", "));
  }
  $("History").appendChild(element);
  $("HistorySection").style.display = "block";
}
